
#include <AT91SAM7X256.H> 
#include <lib_at91sam7x256.h>
#include "AT45DB161.h"
#include "spi.h"
#include "config_BMS.h"
#include "SPI_TOOLS.h"
#define AT45DB161_TIMEOUT        5000000


#define rcvr_AT45DB()	spi(2,0xFF)


typedef struct data_at45
{
	char B0,B1,B2,B3,B4,B5,B6,B7;
}DATA_AT45;


void AT45DB161_init(void)
{
	SPI_Configure_PIO_MAKS(SPI0_PORT,SPI0_PIO_MASK);

	 SPI_Configure(AT91C_BASE_SPI0, 
                  AT91C_ID_SPI0,
                  SPI_MASTER |
				  SPI_ONE_DEVIDE| // SPI Connct TO 1Device {NO MOLTI DEVICE}
				  SPI_MOD_FDIS |
				  SPI_PCS(2)
				   // Value of the SPI configuration register.
    );    
    
    

	SPI_ConfigureNPCS(AT91C_BASE_SPI0, 2, 	//Config CH2 for AT45DB161 (Flash)
                      AT91C_SPI_NCPHA | SPI_SCBR(1000000, 48000000) |
                      SPI_DLYBS(1000, 48000000) | (0xC8 << 8) );
    
    SPI_Enable(AT91C_BASE_SPI0);
}

static struct data_at45 SendCommand(unsigned char bCmd ,char length_r)
{
   
//    unsigned int  uResult = 0;
    unsigned int  uTimeout = 0;
	DATA_AT45 rx_data;
    // (volatile declaration needed for code optimisation by compiler)
    volatile unsigned char bufferRX[10]; 
    volatile unsigned char bufferTX[3];
    
    AT91PS_PDC pPdc = (AT91PS_PDC) &(AT91C_BASE_SPI0->SPI_RPR);
    unsigned int dStatus;  
  
    bufferRX[0] = 0;
    bufferRX[1] = 0;
    bufferRX[2] = 0;
    
    bufferTX[0] = bCmd;
    bufferTX[1] = 0;
    bufferTX[2] = 0;//bCmd;
    
    // Send Command and data through the SPI
    pPdc->PDC_PTCR = AT91C_PDC_RXTDIS;
    pPdc->PDC_RPR = (unsigned int) bufferRX;
    pPdc->PDC_RCR = length_r;    
    
    pPdc->PDC_PTCR = AT91C_PDC_TXTDIS;
    pPdc->PDC_TPR = (unsigned int) bufferTX;
    pPdc->PDC_TCR = 3;
    
    pPdc->PDC_PTCR = AT91C_PDC_RXTEN;
    pPdc->PDC_PTCR = AT91C_PDC_TXTEN;

    do {
        dStatus = AT91C_BASE_SPI0->SPI_SR;
        uTimeout++;
    }
    while ((( dStatus & AT91C_SPI_RXBUFF) != AT91C_SPI_RXBUFF) && (uTimeout < AT45DB161_TIMEOUT));

    pPdc->PDC_PTCR = AT91C_PDC_RXTDIS;   
    pPdc->PDC_PTCR = AT91C_PDC_TXTDIS;    
    
   	rx_data.B0 = bufferRX[0];
	rx_data.B1 = bufferRX[1];
	rx_data.B2 = bufferRX[2];
	rx_data.B3 = bufferRX[3];
	rx_data.B4 = bufferRX[4];
	rx_data.B5 = bufferRX[5];
	rx_data.B6 = bufferRX[6];
	rx_data.B7 = bufferRX[7];
    
    return rx_data;		  
}

unsigned char Status_Register_read(void)
{
	unsigned char Register;
	spi(2,0xD7);
	Register = rcvr_AT45DB();
	//Register = SendCommand(0xD7,2);   //send 0xD7 Recieve 2 Byte

	return Register;
	
}

void Manufactor_ID_Read(void)
{
	unsigned char i, j ;
  	DATA_AT45 data_in; 
  
	data_in.B3 = spi(2,0x9F);
	//dara_in = SendCommand(0x9F,4);
	data_in.B0 = rcvr_AT45DB();
	data_in.B1 = rcvr_AT45DB();
	data_in.B2 = 0x20;
//while(spi(2,0x9F) != 0x1f);
	if( (data_in.B0 == 0x1F) && (data_in.B1 == 0x26) )
	{
	  LED1(1);
	  rcvr_AT45DB();
	  rcvr_AT45DB();
	} 

	LCD_ShowNum(0,0,data_in.B0 ,3,16);
	LCD_ShowNum(0,30,data_in.B1 ,2,16);
	LCD_ShowNum(20,0,data_in.B2 ,2,16);
	LCD_ShowNum(50,0,data_in.B3 ,3,16);
	for(j=0;j<4;j++)
	 {
	  // USART_1_Transmit(DATA_IN_MISO[j]); //printf("0x%x \n",DATA_IN_MISO[j]);    //
	 }
}


